\documentclass[xcolor=dvipsnames]{beamer}

\usepackage[T1]{fontenc}
\usepackage{lmodern}
\usepackage[utf8]{inputenc}
\usepackage{textpos}
\usepackage{color}
\usepackage[dvipsnames]{xcolor} %http://www.maths.adelaide.edu.au/anthony.roberts/LaTeX/ltxusecol.php
\usepackage{hyperref}
\usepackage{listings}
%% \usepackage{listings-dlang}

%% TODO remove when listings-dlang works to provide this macro

\lstdefinelanguage{D}{
  sensitive=true,
  showstringspaces=false,
  morekeywords = [1] { abstract, alias, align, auto, scope, body, break,
    cast, catch, class, const, continue, debug, delegate, delete, deprecated,
    do, else, enum, export, false, final, finally, for, foreach,
    foreach_reverse, function, goto, if, immutable, import, in, inout,
    interface, invariant, is, lazy, macro, mixin, module, new, nothrow, null,
    out, override, package, pragma, private, protected, public, pure, ref,
    return, shared, static, struct, super, switch, synchronized, template, this,
    throw, true, try, typedef, typeid, typeof, union, unittest, volatile, while,
    with, assert },
  morekeywords = [2] {enforce},
  morekeywords = [3] { __DATE__, __EOF__, __FILE__, __LINE__, __TIMESTAMP__,
    __TIME__, __VENDOR__, __VERSION__, __ctfe, __gshared, __monitor, __thread,
    __vptr, _argptr, _arguments, _ctor, _dtor, __traits },
  morekeywords = [4] { byte, ubyte, short, ushort, int, uint, long, ulong, cent,
    ucent, void, bool, bit, float, double, real, ushort, int, uint, long, ulong,
    float, char, wchar, dchar, string, wstring, dstring, ireal, ifloat, idouble,
    creal, cfloat, cdouble, size_t, ptrdiff_t, sizediff_t, equals_t, hash_t },
  morestring = [b]{"},
  morestring = [b]{'},
  morestring = [b]{`},
  %% https://latexcolor.com/
  keywordstyle = [1]\bfseries\color{teal},
  keywordstyle = [2]\bfseries\color{violet},
  keywordstyle = [3]\bfseries\color{violet},
  keywordstyle = [4]\bfseries\color{ForestGreen},
  stringstyle = \color{magenta},
  numberstyle = \color{orange},
  comment = [l][\color{brown}]{//},
  morecomment = [s][\color{brown}]{/*}{*/},
  morecomment = [s][\color{brown}]{/**}{*/},
  morecomment = [n]{/+}{+/},
  morecomment = [n][\color{brown}]{/++}{+/},
}

% \usepackage[swedish]{babel} %To get a swedish style of the document, swedish typographical rules and so on

\lstset{language=D}
\lstset{basicstyle=\footnotesize\ttfamily,breaklines=true}
%% \lstset{language=D,
%%   morecomment=[l][\color{magenta}]{\#}
%% }

\usetheme{Boadilla}              %default, Boadilla
\usecolortheme[named=Maroon]{structure}

\title[Why D?]{The D Programing Language\\dlang.org}
\author[Per Nordlöw% , HiQ
]{\textbf {Per Nordlöw% \\HiQ
}} % auteur

% \useoutertheme{umbcfootline}
\setbeamertemplate{background canvas}[vertical shading][bottom=red!20,top=yellow!30]
% \setbeamertemplate{background}[grid][step=5mm,color=blue]
% \setbeamertemplate{background}{\includegraphics[width=\paperwidth]{sunset.jpg}}

\begin{document}

% Titleframe
\begin{frame}[fragile]
  \begin{figure}
    \includegraphics[width=0.5\textwidth]{d-logo-from-svg}
  \end{figure}
  \maketitle
\end{frame}

% \addtobeamertemplate{frametitle}{}{%
% \begin{textblock*}{100mm} (.85\textwidth,-0.5cm)
% \includegraphics[height=1cm,width=2cm]{hiq}
% \end{textblock*}}

\begin{frame}[fragile]{Trend: It's human to err!}
  \begin{figure}
    \fbox{\includegraphics[width=0.72\textwidth]{human2err}}
  \end{figure}
  \begin{itemize}[<+->]
  \item Legacy: Humans don't err
  \item Changing Tides
    \begin{itemize}[<+->]
    \item Git: Mistakes Allowed: ``Rewrite history''
    \item No Programming Priesthood
    \end{itemize}
  \item Humans \& Machine Redundancy
  \item Error Correction
  \item Error Resilience
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Software Process Goal:\\Detect Errors as \emph{Early as} Possible}
  % \fbox{\centering\includegraphics[width=0.8\textwidth]{human2err}}
  \begin{itemize}[<+->]
  \item \textbf{Build} (Compile, Link): Static Syntax \& Semantic Checking.  D's
    scope, Rust's ownership and borrowing (C++/D at run-time), aliasing leads to
    bugs such as iterator invalidation, either one writer or many readers, not
    both,
  \item \textbf{Test \& Coverage Test}: Dynamic Checking
  \item \textbf{Run}: Dynamic Checking
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Type System is the Key}
  \begin{itemize}[<+->]
  \item Information Propagation (DRY): Reflection
  \item Rich Type Programming: Default, Range, Step, Saturation, Physical Unit
  \item Requires \emph{Formal} Language to Capture its Algebra!
  \item Type Inference: Unit Analysis
  \item \emph{Type Safe Linking}: Should Change Everything! We just need to
    fixed GNU ld. GCC already puts types in debug information
  \item Trend: Static code inference can give guarantees on
    (concurrent) code!:\\
    Examples: Rust, Haskell, D, Scala, OCaml, F\#, Julia partly C\#
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Scalability}
  \begin{itemize}[<+->]
  \item What is the largest (personal) project you've written?
  \item Why did you stop?
  \item How did that feel?
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Error Handling Alternatives}
  \begin{itemize}[<+->]
  \item \textbf{Return Value}:
    \begin{itemize}[<+->]
    \item Nobody checks return of \texttt{printf} nor \texttt{malloc} in C
    \item Try running programs on a system almost out of memory or disk
    \end{itemize}
  \item \textbf{Exceptions}:
    \begin{itemize}[<+->]
    \item Stroustrup on its performance
    \item Almost religious wars
    \item Polynomial Complexity
    \item Cleanup scope
    \item Exception safe constructors
    \end{itemize}
  \item \textbf{Scope}:
    \begin{itemize}[<+->]
    \item D-only
    \item Linear complexity
    \item Compiler generates nested try-catch expressions
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Redundancy}
  \begin{figure}
    \fbox{\includegraphics[width=0.50\textwidth]{fired}}
  \end{figure}
  % \begin{figure}
  %   \fbox{\includegraphics[width=0.50\textwidth]{cat}}
  % \end{figure}
  \begin{itemize}[<+->]
  \item Compactest code is random but impossible to understand and correct
  \item Managers!: Computers have no common sense!
  \item Not just numerics but
  \item Units, Default-Value, Range, Saturation, Ownership, Access, etc
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Interaction with Structured Information}
  \begin{itemize}[<+->]
  \item Limit input to very specific structure in
  \item GUI/Webb Forms
  \item Example: Personal Codes, Dates, etc
  \item Lazy Programmers: Integrate pattern matching with UI component input
    logic and reuse!
  \item Leaders!: Investment always pays off in the long run!
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{General Tips}
  \begin{itemize}[<+->]
  \item Minimize Number of \textbf{Configurations}, especially in dynamic languages
  \item Minimize Number of \textbf{Code Paths}
  \item Learn \& Use \textbf{Reflection} (Static \& Dynamic) =>
  \item \textbf{Propagate Information Structure} to
    \begin{itemize}[<+->]
    \item Command Line
    \item GUIs
    \item Protocols (showcase Boost.Serialization)
    \item etc
    \end{itemize}
  \item Make it impossible for user to enter incorrectly formatted data
  \item Separate logic from presentation (CSS, LaTeX, Qt-XML)
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Dinner!}
  \begin{figure}
    \fbox{\includegraphics[width=1.0\textwidth]{werewolf}}
  \end{figure}
\end{frame}

\begin{frame}[fragile]{Iron Man like Systems and Interfaces?}
  How do we turn software engineers into Tony Starks?
  \begin{figure}
    \fbox{\includegraphics[width=0.60\textwidth]{stark}}
  \end{figure}
  and what language shall we bootstrap this with!?
\end{frame}

\begin{frame}[fragile]{D: The Scientist and The Engineer}
  \begin{figure}
    \fbox{\includegraphics[width=0.80\textwidth]{andreibright}}
  \end{figure}
  \pause{}

  \emph{D is a systems programming language with C-like syntax and static
  typing. It combines efficiency, control and modeling power with safety and
  programmer productivity.}
  %% \begin{itemize}[<+->]
  %% \item History and Development of Walter Bright and D is very similar to that
  %%   of Linus Torvalds and Linux
  %% \end{itemize}
\end{frame}

\begin{frame}[fragile]{Machines, Software and Trust}
  \begin{figure}
    \fbox{\includegraphics[width=0.5\textwidth]{xman}}
  \end{figure}
  \begin{itemize}[<+->]
  \item Why do \textit{today's} programs crash?
  \item Car Bulb Analogy
  \item \emph{Must} they?
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Company Language Usage Trend}
  \begin{itemize}[<+->]
  \item C for builtin (IOT) devices. Unsafe. Fast iteration.
  \item Rust for builtin (IOT) devices. Very slow (uncached) iteration.
  \item C++ for backend. Slow iteration.
  \item C\# or Java for GUI and Db. Good IDE+GUI integration. High productivity
    but slower (than system languages C, C++, Rust, \ldots) especially with
    generics. Java and C\# doesn't have templates, they have generics being at
    least a magnitude slower than C++ (and D).
  \item Qt for GUI (on Linux)
  \item Shell and Bash for scripting. Fast iteration.
  \item Question: Does an organisation really need so many languages?
  \item Language wrappers are unsafe (partly because of type-safe linking)
  \item Conclusion: Desperate need for a language that combines the best of
    these.
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Language Trend}
  \begin{itemize}[<+->]
  \item Industry has been stuck in a local minimum with C/C++ for a long
    time. It's time to change this
  \item \textbf{Trend}: As fast C/C++ but provably safe
  \item \textbf{Languages}: D, Mozilla's Rust, Apple's Swift, MS's M\# all have:
    \begin{itemize}[<+->]
    \item Static type inference
    \item Strict immutability
    \item Explicit control of memory layout and allocation
    \end{itemize}
  \item \textbf{Rust}: Safe but with powerful control
  \item Either stick with it, or try to change it
    %% \item Restrictive languages, such as Ada, looses all its safety in the
    %%   wrapping layer
    % \item Background for Ada: Before 100s of langs in US Defence
    % \item Why do we keep on torturing ourselves with obselete/faulty languages?
    %% \item Why am I doing this?
    %%   \begin{itemize}[<+->]
    %%   % \item About me
    %%   % \item Time
    %%   % \item Age
    %%   \item Lifes too short for bad code
    %%   \end{itemize}
    % \item Help/Promote D and alikes
    % \item Get to work on what's meaningful
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Why should you learn about D?}
  \begin{itemize}[<+->]
  \item \textbf{Developer have Responsibility}:
    \begin{itemize}[<+->]
    \item If we aren't aware
    \item We won't ask for it and
    \item We will not get it (in languages in general)
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Democratic \& Pragmatic Fundaments}
  \begin{columns}[c] % the "c" option specifies center vertical alignment
    \column{.65\textwidth}
    \begin{itemize}[<+->]
    \item Gold is \emph{not} everything that\ldots --- Big leaps are
      \emph{not} made by the largest
    \item \textbf{Prestigeless Non-Company Controlled}: No more:
      \textit{``Lets reinvent everything because we want to be
        different''}
    \item \textbf{No Priesthood} nor too Academic
    \item We have done our homework
    \item C/C++/C\#-like to \textbf{ease transition}
    \item \textbf{Pragmatic}: Developers want to GTD
    \item \textbf{Democratic/Dynamic}: Key solutions voted for. All about
      \emph{probabilities}
    \item \textbf{Continuous Integration} on Github
    \item Linux-style Deprecation Model
    \end{itemize}
    \column{.35\textwidth}
    \begin{figure}
      \fbox{\includegraphics[width=0.9\textwidth]{pragmatic}}
    \end{figure}
  \end{columns}
\end{frame}

\begin{frame}[fragile]{Goal}
  of D is to be
  \begin{itemize}[<+->]
  \item \textbf{Safe/Correct}: Highest priority
  \item \textbf{Productive}: Low Threshold, Expressive => Creative. Productivity
    proportional to compile-time + run-time (see
    \href{https://github.com/nordlow/compiler-benchmark}{compiler-benchmark}).
  \item \textbf{Performant}: Fast Build \emph{and} Fast Execution (DMD selling point)
  \end{itemize}
  \begin{itemize}[<+->]
  \item \textbf{Other}: 2 out of 3
  \item \textbf{D}: 3 out of 3!
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe: \emph{Provably} not Probably Correct}
  \begin{itemize}[<+->]
  \item No more faith-based programming
  \item C\#-Designer: ``Billion-Dollar mistake in C''
  \item Prevent null references (zero pointers)? Solutions:
    \begin{itemize}[<+->]
    \item \textbf{Haskell}: \texttt{Maybe}
    \item \textbf{Ada 2005}: \texttt{not null}
    \item \textbf{Rust}: By default!
    \item \textbf{Java 8}: Type annotation \texttt{@NotNull}
    \item \textbf{D}: \texttt{Nullable}
      %% \texttt{NotNull}, Maybe Language:
      %% \texttt{@nullable} required in \texttt{@safe} D code with extra compiler
      %% switch
    \end{itemize}

  \item Provably Correct:
    \begin{itemize}[<+->]
    \item Rust takes correctness further: No implicit aliasing, prevents iterator
      invalidation and unexpected exceptions
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe: Safety Levels}
  Some software needs low-level access. Classification of code eases bug
  isolation:
  \begin{itemize}[<+->]
  \item \texttt{@safe} can call \texttt{@safe} and in turn
  \item \texttt{@trusted} can call \texttt{@trusted} and in turn
  \item \texttt{@system} can call \texttt{@system} and C code
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe: Safety Levels}
  \texttt{@safe} functions can
  \begin{itemize}[<+->]
  \item unrefer pointers but
  \item \emph{not} null-initialize nor do arithmetic on them
  \item \emph{not} do any memory recast dribblings
    % \item No byteorder problems =>
    % \item Architecture Independence
  \item \emph{not} do unsafe \texttt{cast}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Expressive:\@ Reuseable Software}
  \begin{figure}
    \fbox{\includegraphics[width=0.6\textwidth]{whirl}}
  \end{figure}
  How can we
  \pause{}
  \begin{itemize}[<+->]
  \item Write truly reusable software components?
  \item Escape ``Whirlpool Programming''?
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Expressive:\@ Component Programming Pipeline}
  \begin{figure}
    \fbox{\includegraphics[width=1.0\textwidth]{pipe}}
  \end{figure}
  Successful model in
  \begin{itemize}[<+->]
  \item As Western text: Left-to-right
  \item Proof of Concept: UNIX Commands \& Pipes
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Expressive:\@ Component Programming Example}
  ``Read lines, sort em and print em back'':
  \begin{lstlisting}[frame=single]
    import std.stdio, std.algorithm, std.range, std.array;

    void main(string[] args)
    {
      stdin.byLine(KeepTerminator.yes)
      .map!(_ => _.dup)
      .array
      .sort()
      .copy(stdout.lockingTextWriter());
    }
  \end{lstlisting}
  as fast as C++ but way simpler for the author, maintainer and compiler
  (optimizer) to reason about
\end{frame}

\begin{frame}[fragile]{Expressive:\@ Component Programming realized by}
  \begin{itemize}[<+->]
  \item \textbf{Generics} (= reuse) made simple
  \item \textbf{Ranges}
    \begin{itemize}[<+->]
    \item Lazily evaluated means
    \item Return calculation instead of value
      %% \item Also called higher-order range pattern
      %% \item Compare with Monad
    \item Example:
      \begin{lstlisting}[frame=single]
        writeln(x,y,z); // no heap
        writeln(x~y~z); // use heap, revealed with -vgc
        writeln(only(x, y, z)); // no heap (std.algorithm.only)
        writeln(tuple(pair(x1,x2), y, z)); // composable, no heap
      \end{lstlisting}
    \item Concept easily confused with \emph{value} ranges such as Ada's
      \emph{Range Types}
    \end{itemize}
  \item Uniform Call Syntax (\textbf{UFCS})
  \item \textbf{Emptyness Propagation of Ranges}: no if statments to check for
    null etc enables. Removes need for error handling (exceptions nor error
    status returns).
    %% \item \textbf{Inlineable} gives C/C++ performance
    %% \item \textbf{Arrays}, \textbf{Strings} builtin
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Generics is $n_A+n_C$}
  \begin{itemize}[<+->]
  \item Algorithms are the axioms and always come first
    \begin{itemize}[<+->]
    \item \texttt{Reversion}
    \item \texttt{Levenshtein distance}
    \item \texttt{Binary search}, \texttt{Quicksort}
    \end{itemize}
  \item $n_A$ number of algorithms, $n_C$ number of containers
  \item Only $n_A+n_C$ scales, not $n_A\cdot n_C$
  \item Generic function in Rust?
  \item No hierarchy (a la Java/C\#) can cover all collections. Example: Bloom
    filter. Instead we need
  \item Andrei's wider defintion:
    \href{https://www.google.com/search?channel=fs&q=design+by+introspection}{``Design
      by Introspection''} realized via template restrictions and traits
  \item \href{https://youtu.be/tcyb1lpEHm0?t=2715}{Related: The
    Next Big Thing---C++'s if constexpr needs a fix}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Pure Functions}
  \begin{itemize}[<+->]
  \item Definition: a pure function \emph{always} gives the same
    \emph{transformation} of input and return given the same inputs
  \item Enables pure parallel in-place algorithms such as parallel in-place (quick) sort
  \item \emph{Weak} Purity: no reading of global state
  \item \emph{Strong} Purity: Weak Purity along with no \emph{mutation} and
    \emph{aliasing} of input arguments
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Traits \& Ranges}
  \begin{itemize}[<+->]
  \item Trait (C++ Concept): (Minimal Data Interface Requirements)
  \item Core Traits: \texttt{InputRange}, \texttt{OutputRange},
    \texttt{ForwardRange}, \texttt{BidirectionalRange},
    \texttt{RandomAccessRange} (modeled after STL)
  \item In D a traits is a compile-time function returning a boolean value
    (predicate)
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{The Heart of Phobos}
  \begin{itemize}[<+->]
  \item Distinguish between
    \begin{itemize}[<+->]
    \item \textbf{std.range}: data reordering
    \item \textbf{std.algorithm}: computations
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Traits \& Ranges}
  \begin{itemize}[<+->]
    %% \item More Compact/Efficient Encoding (Development) of Algorithms and their
    %%   Variants (in standard lib)
  \item D-only:\@ D ranges propagates properties of wrapped range, such
    as infiniteness, random access, etc
    \begin{lstlisting}[frame=single]
      auto y = x.map!("a*a")}
    \end{lstlisting}
    If \texttt{x} is random access \texttt{y} also is
  \item D-only:\@ D ranges are variadic when possible
  \item Can do limited model-checking at compile-time (forbids allocation from
    infinite range). %% Currently not checked in Rust
  \item \texttt{std.array}: \texttt{array} triggers computation if input is not
    a \texttt{RandomAccessRange}
  \item See Andrei Alexandrescou's article ``Forward is Not Enough''
  \item Ranges and algorithms are more generic than others (STL). For example
    search/find can search for multiple (variadic) keys
    %% \item TODO:\@ Visualizations of behaviour would be nice
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{List of Range Creations 1}
  \begin{itemize}[<+->]
  \item \textbf{\texttt{retro}}: Iterates a bidirectional range \emph{backwards}
  \item \textbf{\texttt{stride}}: Iterates a range with \emph{stride} \texttt{n}
  \item \textbf{\texttt{chain}}: \emph{Concatenates} several ranges into a single range
  \item \textbf{\texttt{roundRobin}}: Given n ranges, creates a new range that return the
    n first elements of each range, in turn, then the second element of each
    range, and so on, in a round-robin fashion
  \item \textbf{\texttt{radial}}: Given a random-access range and a starting
    point, creates a range that alternately returns the next left and next right
    element to the starting point
  \item \textbf{\texttt{take}}: Creates a sub-range consisting of only up to the
    first n elements of the given range
  \item \textbf{\texttt{takeExactly}}: Like take, but assumes the given range
    actually has n elements, and therefore also defines the length property
  \item \textbf{\texttt{takeOne}}: Creates a random-access range consisting of
    exactly the first element of the given range
  \item \textbf{\texttt{takeNone}}: Creates a random-access range consisting of
    zero elements of the given range
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{List of Range Creations 2}
  \begin{itemize}[<+->]
  \item \textbf{\texttt{drop}}: Creates the range that results from discarding the first
    n elements from the given range
  \item \textbf{\texttt{dropExactly}}: Creates the range that results from discarding
    exactly n of the first elements from the given range
  \item \textbf{\texttt{dropOne}}: Creates the range that results from discarding the
    first elements from the given range
  \item \textbf{\texttt{repeat}}: Creates a range that consists of a single element
    repeated n times, or an infinite range repeating that element indefinitely
  \item \textbf{\texttt{cycle}}: Creates an infinite range that repeats the given forward
    range indefinitely. Look ma no types!:
    \begin{lstlisting}[frame=single]
      import std.range;
      auto b = [1,2,3,4]; // buffer
      auto cb = b.cycle; // circular buffer
    \end{lstlisting}
  \item \textbf{\texttt{zip}}: Given n ranges, creates a range that successively returns
    a tuple of all the first elements, a tuple of all the second elements, etc
  \item \textbf{\texttt{lockstep}}: Iterates n ranges in lockstep, for use in a foreach
    loop. Similar to zip, except that lockstep is designed especially for
    foreach loops
  \item \textbf{\texttt{recurrence}}: Creates a forward range whose values are defined by
    a mathematical recurrence relation
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{List of Range Creations 3}
  \begin{itemize}[<+->]
  \item \textbf{\texttt{sequence}}: Similar to recurrence, except that a random-access
    range is created
  \item \textbf{\texttt{iota}}: Creates a range consisting of numbers between a starting
    point and ending point, spaced apart by a given interval
  \item \textbf{\texttt{frontTransversal}}: Creates a range that iterates over the first
    elements of the given ranges
  \item \textbf{\texttt{transversal}}: Creates a range that iterates over the n'th
    elements of the given random-access ranges
  \item \textbf{\texttt{indexed}}: Creates a range that offers a view of a given range as
    though its elements were reordered according to a given range of indices
  \item \textbf{\texttt{chunks}}: Creates a range that returns fixed-size chunks of the
    original range
  \item \textbf{\texttt{only}}: Creates a range that iterates over a single value
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Uniform Call Syntax (UFCS)}
  \begin{itemize}[<+->]
  \item \texttt{needle.findIn(haystack)} is more obvious than
  \item \texttt{findIn(needle, haystack)}
  \item Useful in conversion extensions such as: \texttt{msgpack-d} as
    \begin{itemize}[<+->]
    \item \texttt{value.pack}
    \item \texttt{value.unpack}
    \end{itemize}
  \item std.conv.to! makes API-integration transparent
    %% \item Chained Left-to-Right: \texttt{data.doThis.doThat;}
    %% \item Ruby-Style: \texttt{"/bin/ls".isFile}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Concrete range example}
  \begin{itemize}[<+->]
  \item Check if a \texttt{range} is a symmetric (textual palindrome)
    \begin{lstlisting}[frame=single]
      bool isSymmetric(Range)(in Range x)
      if (isBidirectionalRange!Range)
      {
        import std.algorithm: retro, equal;
        return x.retro.equal(x);
      }
      alias isPalindrome = isSymmetric;
    \end{lstlisting}
  \item D ``knows'' that UTF-8 encoded strings are bidirectional ranges
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Data Semantics}
  \begin{itemize}[<+->]
  \item Like in C\#
  \item Both are needed:
    \begin{itemize}[<+->]
    \item \emph{Value} Semantics: \texttt{struct} (fixed-length vectors, arrays, etc)
    \item \emph{Reference} Semantics: \texttt{class} (tree-nodes, etc)
    \end{itemize}
  \item Distinction between \texttt{->} and \texttt{.} is not needed. Eases
    substitutions between \texttt{struct} and \texttt{class}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safer and Easier Class Polymorphism}
  \begin{itemize}[<+->]
  \item \emph{All} members functions by default virtual
  \item No \texttt{virtual} keyword needed
  \item Overriding must be explicit through \texttt{override}
  \item Member qualifier \texttt{final} makes them non-virtual
  \item Final members can't be overridden in sub-classes
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Basic Needs Builtin}
  \begin{itemize}[<+->]
  \item Arrays: \texttt{ubyte[]}
  \item Strings: \texttt{string} (same as \texttt{immutable(char)[]})
  \item Maps (Associative Arrays): \texttt{ubyte[string]}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Self-contained arrays corrects ``C's Largest Mistake'': }
  Arrays are ``Fat'' Pointers (Pointer + Length):
  \pause
  \begin{itemize}[<+->]
  \item \textbf{Static} (Stack) Compile-Time Checked with \textit{Value}-Semantics:\\
    \begin{lstlisting}[frame=single]
      int[2] a;
      int[3] b;
      ubyte[\$] b = [1,2,3]; // type given, length inferred (v2.066)
      a[] = b[]; // mismatched array lengths, 2 and 3
    \end{lstlisting}
  \item \textbf{Dynamic} (GC-Heap) Run-Time Checked with \textit{Reference}-Semantics:\\
    \begin{lstlisting}[frame=single]
      int[2] a;
      auto b = [1,2,3];
      a[] = b[]; // lengths don't match for array copy, 2 = 3
    \end{lstlisting}
    %% GC-escapeable from function calls makes use easy and robust
  \item \textbf{Scoped} (Heap): Deterministic Destruction:\\
    \begin{lstlisting}[frame=single]
      scope a = [1,2]; // destructed when `a` goes out of scope
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Arrays Builtin \& Done Right}
  \begin{itemize}[<+->]
  \item Easier Transition from C/C++ with:
    \begin{itemize}[<+->]
    \item \textbf{C-Style Arrays Compatible}: \texttt{int a[2];}
    \item \textbf{Partially C Compatible}: ``If C-code compiles its behaviour
      will be the same''
    \end{itemize}
    %% \item Compare with C/C++11/C++14’s Complexity: \texttt{T[]}, C99 VLA,
    %%   \texttt{std::vector}, \texttt{std::array}, \texttt{std::valarray},
    %%   \texttt{std::dynarray}, etc
  \item Index bounds-checking by default (even in release mode): many (browser)
    security holes are buffer overruns
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Pragmatic Array Slice Semantics}
  Eventhough this, at first sight, seem inconsisent this is \emph{really} what
  we want in pattern (regexp) matching algorithms
  \begin{itemize}[<+->]

  \item Pointer part decide ``\textbf{null}ness'' and Bool Conversion
    \begin{lstlisting}[frame=single]
      static assert([].ptr != null);
      static assert("ab"[$..$].ptr == null);
      static assert(![]);
      static assert(!null);
    \end{lstlisting}
  \item Zero-length slices are not null
    \begin{lstlisting}[frame=single]
      static assert("ab"[0..0] == []);
      static assert("ab"[$..$] == []);
      static assert("ab"[$..$] !is null);
      static assert("ab"[$..$] == null);
      static assert("ab"[0..0] == "ab"[$..$]);
      static assert("ab"[0..0]); // contextual hit (BOL)
      static assert("a\nb"[2..2]); // contextual hit (beginning of second line)
      static assert("ab"[$..$]); // contextual hit (EOL)
    \end{lstlisting}

  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Associative Arrays (Maps) Builtin \& Done Right}
  No need for separate initialization/construction of AA-values as in
  \begin{lstlisting}[frame=single]
    string[int] tags;
    tags[13] ~= "Alice";
  \end{lstlisting}
  via templated aggregate member, for instance,
  \begin{lstlisting}[frame=single]
    ref Value opIndexOpAssign(string op, Rhs)(Rhs rhs, Key key) if (op == "+" || op == "-")
  \end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Strings Builtin \& Done Right}
  \begin{itemize}[<+->]
  \item Unicode Builtin: UTF-8/16/32 = \texttt{string} \texttt{wstring}
    \texttt{dstring} are by default \texttt{immutable} ranges. This enable for
    example
  \item ASTs to refer directly to GC:ed source string (slice) instead of a
    heap-allocated copy
  \item No heap allocation of read-only copies
  \item D XML/JSON-parsers fastest in the world (see benchmark below)
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{String Types}
  \begin{itemize}[<+->]
    %% \item Distinction between
    %%   \begin{itemize}[<+->]
    %%   \item String \texttt{string} and character \texttt{char}:  and
    %%   \item Array of bytes: \texttt{ubyte[]}
    %%   \end{itemize}
  \item String overview
    \begin{figure}
      \tiny
      \begin{tabular}{ c | c | c | c | c }
        \textit{Letter type} & \textit{String type} & \textit{Code length} & \textit{Range trait} & \textit{Algorithm(s)} \\
        \hline
        \texttt{char}, \texttt{wchar} & \texttt{string}, \texttt{wstring} & Variable & Bidirectional & Levenshtein distance\\
        \hline
        \texttt{dchar} & \texttt{dstring} & Fixed & RandomAccess & Quick Sort\\
      \end{tabular}
    \end{figure}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Iteration Done Right: foreach}
  \begin{itemize}[<+->]
  \item Like C++11 range-based for-loop but without need for \texttt{auto}:
    \begin{itemize}[<+->]

    \item By Value:\\
      \begin{lstlisting}[frame=single]
        foreach (element; range) {}
      \end{lstlisting}

    \item By Reference:\\
      \begin{lstlisting}[frame=single]
        foreach (ref element; range) {}
      \end{lstlisting}
    \end{itemize}

  \item With optional index:\\
    \begin{lstlisting}[frame=single]
      foreach (index, element; range) {}
    \end{lstlisting}

    %%   \item Tuple unpacking
    %%       \begin{lstlisting}[frame=single]
    %% foreach (index, tupleElementA, tupleElementB; rangeOfTuples) {}
    %%       \end{lstlisting}

  \item Indexes seldom needed => fewer bugs
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Programming Styles Overview}
  \begin{itemize}[<+->]
  \item \emph{Imperative} Style (Side-Effects):\\

    \begin{lstlisting}[frame=single]
      foreach (elt; range) {
        elt.doSideEffect;
      }
    \end{lstlisting}

  \item \emph{Functional} Style (no Side-Effects):\\
    \begin{lstlisting}[frame=single]
      auto result = range.map!"a*a";
    \end{lstlisting}

  \item \emph{Combined} Style:\\
    \begin{lstlisting}[frame=single]
      foreach (elt; range.map!"a*a") {
        elt.doSideEffect;
      }
    \end{lstlisting}

  \item \emph{Functional-Lambda} (White?) Style:\\
    \begin{lstlisting}[frame=single]
      10.times!({ doSideEffect; });
    \end{lstlisting}

  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Correctness: \texttt{unittest} builtin everywhere}
  \begin{itemize}[<+->]
  \item Minimal overhead for TDD:
    \begin{lstlisting}[frame=single]
      unittest { assert(something); }
    \end{lstlisting}
  \item Executed prior to main if the flag \texttt{-unittest} is given to the
    compiler
  \item Makes it fun to write tests
  \item Can be placed everywhere they belong including generic aggregates!
  \item Great leap in correctness
  \item Combine with coverage checking =>
  \item Fosters robust light-weight abstractions
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Value Range Propagation}
  Thanks to built in static analysis of type ranges
  \begin{itemize}[<+->]
  \item Compiler follows range propagation values and assumes worst-case
    propagation: For example the sum of two 3-bit unsigned integers fits in a
    4-bit unsigned integer
  \item Removes need for dumb casts in place such as
    \begin{lstlisting}[frame=single]
      auto i = 254;
      ubyte ub = i+1; // no cast needed
    \end{lstlisting}
  \item and in places such as
    \begin{lstlisting}[frame=single]
      const i = readInRunTime!ubyte;
      const j = readInRunTime!ubyte;
      const ij = i*j;
      ushort y = ij; // no cast needed
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Composable Types}
  Implementing a value range restricted wrapper type is a no-brainer thanks
  \begin{itemize}[<+->]
  \item Templates restrictions
  \item More compact and powerful operator overloading (\lstinline{opIndex},
    \lstinline{opSlice}, \lstinline{opIndex}, \lstinline{opIndexAssign},
    \lstinline{opIndexOpAssign}) compared to other languages, typically C++
  \item Alias this
  \item struct/class data \lstinline{invariant} code {} plus
  \item \emph{Contract}-Based Programming using
    \begin{lstlisting}[frame=single]
      in {} out (result) {} { /* body... */ }
    \end{lstlisting}
    or even shorter
    \begin{lstlisting}[frame=single]
      in (EXPR) out (EXPR) { /* body... */ }
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Transactional Part 1: \texttt{scope} statement}
  Code complexity grows linearly, not exponentially as with try-catch. Writing a
  \emph{safe} \texttt{cp} in D is trivial.
  \begin{lstlisting}[frame=single]
    import std.exception, std.file;
    void main(string[] args)
    {
      enforce(args.length == 3,
      "Usage: trcopy file1 file2");
      auto tmp = args[2] ~ ".messedup";
      scope(failure) {
        if (exists(tmp))
        remove(tmp);
      }
      copy(args[1], tmp);
      rename(tmp, args[2]);
    }
  \end{lstlisting}
  Compiler rewrites (lowers) statements with \texttt{scope(...)} to
  \texttt{try}-\texttt{catch}-statements.
\end{frame}

\begin{frame}[fragile]{Transactional Part 2: Exception-Safe Constructors and Destructors}
  \begin{itemize}[<+->]
  \item D uses Copy-And-Swap Principle
  \item C++ does not => Not Exception-Safe!
  \end{itemize}
  One can throw from \emph{anywhere}.
\end{frame}

\begin{frame}[fragile]{Build Tool Builtin}
  \begin{itemize}[<+->]
  \item \textbf{\texttt{rdmd hello.d}} when \texttt{hello.d} contains the
    main function
    % \texttt{rdmd} is a wrapper
    % tool around dmd that is include in the DMD distribution
  \item UNIX ``shebang'': \textbf{“As-a-Script-Execution”} using
    \\
    \textbf{\textbf{\texttt{\#!/usr/bin/env rdmd}}}
    % Add it to the beginning of your
    % D main file (which doesn't have to have .d extensions), make it executable
    % and you can run it just as \textit{it were an executable}. This will please
    % script (Python, Ruby) programmers that are used to not having to bother
    % about a build tool
    %% \item For larger projects \textbf{SCons} supports D
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Compilation Performance Facts (2015 laptop)}
  \begin{itemize}[<+->]
  \item Key-enabler: Context-free non-ambiguous grammar
  \item \emph{Single}-Pass (vs C++ 3--7 Passes) makes D
  \item among the fastest compiled languages
    %% \item > 10x faster than C++
  \item D compiler builds in 4 seconds in debug-mode =>
  \item Outstandingly small iteration time for compiler developers
  \item Standard lib builds and runs all its unittests in 2 minutes (debug)
  \item Pay for what is \emph{used}, not what is imported =>
  \item Parses whole standard lib in 0.3 secs in debug-mode, =>
  \item Zero-overhead use of whole of Phobos via (\lstinline{import std;})
  \item Requires fast static analysis (feedback)
  \item \href{https://github.com/nordlow/compiler-benchmark}{compiler-benchmark}: DMD takes 10us (30kcycles) per function. Compare with assembler.
    %% \item \textbf{Quick Iterations}: A Github Pull Request is
    %%   \href{https://d.puremagic.com/test-results/pull-history.ghtml?projectid=1&repoid=1&pullid=3342}{checked}
    %%   on 10 configurations within half an hour!
    %% \item Multi-threading unittesting will give further speedups
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Compilation Speed Consequences 1}
  Enables use of new tools such as
  \begin{itemize}[<+->]
  \item \textbf{dustmite}---a code Minimizer: Automatically isolates bug
    generating a specific error message by minimizing its parenting source
    code. Built into recent distribution of DMD
  \item Instant (1s) Syntactic and Semantic Analysis for Project around 20k lines
  \item \textbf{Type-Rich Programming} finally becomes \emph{practically} doable
    in \emph{real} large projects, not just toy examples (such as in
    \texttt{Boost.Units}). Library error-messages can also be made
    understandable thanks to \emph{alias}es and string template
    arguments. Having (physical) \textbf{unit analysis} checked by the compiler
    is another quantum leap in code correctness
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Compilation Speed Consequences 2}
  “As-a-Script-Execution/Evaluation” using
  \begin{itemize}[<+->]
  \item \textbf{\texttt{\#!/usr/bin/env rdmd}} removes need for build step
    and tool for small applications and enables
  \item Module-Executable-Hybrid Behavior á lá Python, MATLAB, etc
  \item Slogan: ``Fast code, fast''. Less CO2.
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{The Big Picture}
  \begin{itemize}[<+->]
  \item Fastest Parser
  \item Templates everywhere
  \item \textbf{Compiler sees whole program not just single function}
  \item \textbf{Unique Feature}: \emph{Infers} of purity and safety
  \item Better optimizations, safety checks, static analysis, etc
    % \item Previously available in hw languages such as VHDL with huge compilation
    %   times
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe Concurrency}
  \begin{itemize}[<+->]
  \item ``Globals'' Variables \textbf{TLS} by default
  \item No default race-conditions
  \item Fundament: Better
    \begin{itemize}[<+->]
    \item Safe with 3 instructions than
    \item Incorrect with 1 instructions
    \end{itemize}
  \item Cost is about 5 percent slowdown
  \item Thread-global must be tagged with \lstinline{\_\_gshared}
  \item Compare with protected memory in OS
  \item Threads become \emph{isolated} LWP
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe Concurrency: Example}
  \begin{lstlisting}[frame=single]
    import std.concurrency: spawn;

    alias T = string[];

    void useArgs(const T x)
    {
      import std.stdio: writeln;
      writeln("x: ", x);
    }

    void main(T args)
    {
      useArgs(args); // ok to call in same thread
      auto f1 = spawn(&useArgs, args.idup); // ok
      auto f3 = spawn(&useArgs, args); // errors as: "Aliases to mutable thread-local data not allowed."
    }
  \end{lstlisting}

\end{frame}

\begin{frame}[fragile]{Message Passing}
  \begin{itemize}[<+->]
  \item Messages are automatically dynamically typed and can be pattern matched
    on like in dynamic languages. Enabled by close interaction with compiler,
    type mangling (serialization) etc
    \begin{lstlisting}[frame=single]
      import std.concurrency;
      void f(Tid tid)
      {
        receive(
        (int i) { /* do something with i */ }
        );
        send(tid, true);
      }
      void main()
      {
        auto tid = spawn(&f, thisTid); // async call f
        send(tid, 42);
        const ok = receiveOnly!(bool);
        assert(ok);
      }
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Parallelism}
  \begin{itemize}[<+->]
  \item Fibers and Threads
  \item Inside \texttt{std.parallelism}
  \item Task-Based Scheduling \& Stealing
  \item Builtin (no costly 3:rd part such as C++'s Intel TBB)
  \item Builtin \texttt{TaskPool} Singleton
  \item Example:
    \begin{itemize}[<+->]
    \item \texttt{TaskPool.reduce}: 12.170 s
    \item \texttt{std.algorithm.reduce}: 24.065 s
    \end{itemize}
    \begin{lstlisting}[frame=single]
      import std.algorithm : map;
      import std.parallelism : taskPool;
      import std.range : iota;
      void main() {
        immutable n = 1_000_000_000;
        immutable delta = 1.0 / n;
        double getTerm(int i) {
          immutable x = ( i - 0.5 ) * delta;
          return delta / ( 1.0 + x * x ) ;
        }
        immutable pi = 4.0 * taskPool.reduce!"a+b"(n.iota.map!getTerm);
      }
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Floating-Point Correctness}
  \begin{itemize}[<+->]
  \item Defaulted To \textbf{NaN} (Non-A-Number) making it \textit{obvious} that
    a value is undefined (zero is not) when code switches maintainer
  \item NaNs propagate through system without bringing the system down but still
    indicates something is wrong
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Data and Code Restrictions}
  \begin{itemize}[<+->]
  \item Concurrency: \textbf{shared}
  \item Ownership, Data-flow Analysis: \textbf{immutable}, \textbf{const}
  \item Exception: \textbf{nothrow}
  \item Code Access: \textbf{pure}
  \item Memory Safety: \textbf{@safe}
  \item GC Heap Allocation: \textbf{@nogc} and compiler flag \textbf{-vgc}
  \end{itemize}
  enables optimization and auto-parallelization
\end{frame}

\begin{frame}[fragile]{Flexible Memory Management System}
  \begin{itemize}[<+->]
  \item GC-allocation by default or
  \item Manual allocation using \texttt{new} and \texttt{delete}
  \item \texttt{struct} copy ctors more efficient than C++ thanks to
    \textbf{bitblit}
  \item Move-semantics built-in for \texttt{struct} thanks to “postblit”
  \item Allocators: \texttt{std.experimental.allocator}
  \item Copy-ctor disabling plus \texttt{std.algorithm.move()} enables
    Rust-style parameter passing
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Meta-programming: Everything compilers sees is accessible to developer}
  Programmer can access everything compiler ”sees”:
  \begin{itemize}[<+->]
  \item Static (Compile-Time) Reflection
    \begin{itemize}[<+->]
    \item Members of \texttt{struct} and \texttt{class} via \texttt{tupleof} can
      be iterated with \texttt{foreach} makes reflection in for example
      serialization trivial
    \item Enumerators, along with most other builtins, (de)serialized using
      \begin{lstlisting}[frame=single]
        enumInstance.to!string
      \end{lstlisting}
      and
      \begin{lstlisting}[frame=single]
        stringInstance.to!EnumName
      \end{lstlisting}
      given (\texttt{import std.conv: to;})
    \item Type Names using \texttt{T.stringof}
    \item Gives more informative error messages
    \end{itemize}
  \item Propagate Static to Dynamic Reflection
    \begin{itemize}[<+->]
    \item Auto-Generate
    \item Command-Line Interface and
    \item GUI-Look-and-Feel from
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{More Inference than in C++11}
  Along with type inference through \textbf{\texttt{auto}}, also infers
  \begin{itemize}[<+->]
  \item Accessibility (\textbf{\texttt{auto}}, \textbf{\texttt{const}} or
    \textbf{\texttt{immutable}}) using \textbf{inout} parameter and return
    qualifier and
  \item Return by reference or value using \textbf{auto ref}
  \item Reduces code bloat
  \item Only one qualifier needed as in
    \begin{lstlisting}[frame=single]
      auto x = new SomeClass();
      const y = new SomeClass();
      immutable z = new SomeClass();
      scope w = new SomeClass();
    \end{lstlisting}
    opposite to C++'s
    \begin{lstlisting}[frame=single]
      const auto x = new SomeClass();
    \end{lstlisting}
  \item Inference with \textbf{auto} more generic than (C\# \textbf{var}). Not
    limited to variables.
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Expressiveness: Meta-Programming}
  Compile-Time-Function-Evaluation (CTFE),
  \begin{itemize}[<+->]
  \item realized by
    (\textbf{\texttt{pure}} \& \textbf{\texttt{immutable}}) + \textbf{\texttt{static if}}, enables
  \item \texttt{Safety}: Detect Errors before deployment
  \item \textbf{Declarative Programming} generates D code in same compilation
    pass as regular D code:
    \begin{itemize}[<+->]
    \item \texttt{Pegged} on Github replaces external parsing tools
    \item \texttt{std.regex.ctRegex} fastest in the world (2015, 2016 also Rust)
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{When is CTFE Triggered?}
  CTFEable functions (\textbf{\texttt{pure}} with whole body visible) can be either
  \begin{itemize}[<+->]
  \item Evaluated at Compile-time:
    \begin{lstlisting}[frame=single]
      enum e = f();
    \end{lstlisting}
    or
  \item Executed at Run-time:
    \begin{lstlisting}[frame=single]
      auto a = f();
      const c = f();
      immutable i = f();
    \end{lstlisting}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{CTFE + Mixin Magic}
  High-Performance parser generators:
  \footnotesize
  \begin{lstlisting}[frame=single]
    import pegged.peg;
    import pegged.grammar;
    pragma(lib, "pegged");

    mixin(grammar(`Arithmetic:
    Term     < Factor (Add / Sub)*
    Add      < "+" Factor
    Sub      < "-" Factor
    Factor   < Primary (Mul / Div)*
    Mul      < "*" Primary
    Div      < "/" Primary
    Primary  < Parens / Neg / Number / Variable
    Parens   < "(" Term ")"
    Neg      < "-" Primary
    Number   < ~([0-9]+)
    Variable <- identifier`));

    unittest {
      enum parseTree1 = Arithmetic("1 + 2 - (3*x-5)*6");
      assert(parseTree1.matches == ["1", "+", "2", "-",
        "(", "3", "*", "x", "-", "5", ")", "*", "6"]);
    }
  \end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Concise and Uniform Syntax}
  \begin{lstlisting}[frame=single]
    ubyte someByte = 13;
    string someString = "alpha";
    auto someNumber = 42;
    enum someConstant = 1;
    const iPromiseToNeverChangeThisValue = 1;
    immutable thisValueCanNeverBeChangedByAnyone = 1;
    alias goodName = badName; // potentially many overloads
  \end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Easy, Flexible \& Safe Module System}
  \begin{itemize}[<+->]
  \item No need for separate \texttt{.h} and \texttt{.c} to keep in sync by
    default...but
  \item Compiler can \textbf{auto-generate interface files} if needed
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Easy, Flexible \& Safe Module System}
  \begin{itemize}[<+->]
  \item \textbf{Hijack-Safe}
  \item Imports automatically ``used'' (like C++’s \texttt{using namespace})
  \item No \emph{need} to qualify symbols like in Python's \texttt{os.path.join()}
  \item Overloads seldom collide
  \item Not possible in dynamic languages
  \item When they \emph{do} collide uniquify with scope qualifier
  \item \textbf{Scoped} Imports (inside structs, classes, functions, templates, etc)
  \item \textbf{Cyclic} Imports (Dependencies) just works, compared to C/C++,
    Python
  \item Eases code modularization into new files
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Safe Integer Literals}
  \begin{itemize}[<+->]
  \item No need to ULL-suffix 64-bit Constants which C++ needs:
    \begin{lstlisting}[frame=single]
      0x0000_1111_2222_3333ULL
    \end{lstlisting}
  \item Static Type Analysis of Constants for Implicit Casts
    \begin{itemize}[<+->]
    \item Ok:
      \begin{lstlisting}[frame=single]
        int x = cast(ulong)0x0000_1111;
      \end{lstlisting}
    \item Error:
      \begin{lstlisting}[frame=single]
        int y = 0x0000_1111_2222_3333;
      \end{lstlisting}
    \item Ok:
      \begin{lstlisting}[frame=single]
        int z = cast(int) 0x0000_1111_2222_3333;
      \end{lstlisting}
    \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Expressiveness: Type Construction}
  Haskell-Like Elegance in Type Construction:
  \begin{lstlisting}[frame=single]
    alias Pair(T) = Tuple!(T, T);
  \end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Type-Safe Command Line Argument Parsing}
  \begin{itemize}[<+->]
  \item Type-aware argument parsing (\texttt{std.getopt})
  \item Just define typed variable and give it as reference into a type aware
    overloaded \texttt{registerArgument(type)}
  \item Type information infers to interface generation
  \item DRY!
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Documentation Generation Builtin}
  \begin{itemize}[<+->]
  \item DDoc builtin to the compiler
  \item Runs during compilation
  \item Checks docs against function signatures
  \item Unnoticeable performance overhead
  \item Generates HTML, PDF
    %% \item D also supported by Doxygen
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Compatibility with C/C++}
  \begin{itemize}[<+->]
  \item ABI Compatible with C, most of C++ and soon Objective-C (Apple IOS) through \texttt{extern}
  \item No Surprises when porting: C constructs that compiles in D should
    behave the same as in C
  \item @safeness of templated functions are automatically deduced by compiler
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Other Improvements}
  \begin{itemize}[<+->]
  \item \textbf{Multi-Dim Slicing} a la Matlab/Fortran: \texttt{x[0..m, 0..n]}
  \item Compacter generics using \texttt{static if}
  \item No darn semicolons after classes/structs
  \item \textbf{Power-operator}: ^^
  \item \textbf{Nested functions}: Capture scope of parent
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Compilers}
  \begin{itemize}[<+->]
  \item \textbf{DMD}: Reference (Recent Features), Fast Compile
  \item \textbf{LDC}: LLVM (ca 1 month behind DMD), Fast Code
  \item \textbf{GDC}: GCC (ca 1--2 years behind DMD), Fast Code
  \end{itemize}
  Frontend parts are in D
\end{frame}

\begin{frame}[fragile]{IDEs}
  \begin{itemize}[<+->]
  \item \textbf{Visual D}: (Visual Studio):
  \item \textbf{Eclipse DDT}:
  \item \textbf{Emacs FlyCheck}: Including visual feedback overlays of unittests!
  \item \textbf{DCD}: D Completion Daemon: Server-Client! Frontends for Emacs,
    Vi, Sublime Text, etc
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Diagnostics}
  \begin{itemize}[<+->]
  \item Why aren't all useful diagnostics active by default in compilers?
  \item No false positives is crucial for experience.
  \item False negatives gives inconsistent developer experience.
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Learning Curve \& Cons}
  \begin{itemize}[<+->]
  \item When do we need explicit slicing \texttt{x[]}?
  \item Compiler diagnostic needs improvement
  \item Template instance syntax: \texttt{Tuple!(S,T,U)}
    %%   \item Compile-time constants (like C's \texttt{#define}):
    %% \begin{lstlisting}[frame=single]
    %%   enum thisConstantCanNeverChange = 42;
    %% \end{lstlisting}
    % \item Perhaps \texttt{@safe pure nothrow} should have been default\ldots
    %% \item CTFE is slow for complex usage such as \textbf{Pegged}. Is being
    %%   rewritten by Stefan Koch
  \item GC dependency prevents C++-based companies from switching to D
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Trend: Safe Memory-Models}
  \begin{itemize}[<+->]
  \item C,C++ is not built to provide ownership control and safe memory slicing,
    so range checking gives a significant performance hit
  \item In D slice-splitting can be made \texttt{@safe} without bounds-checking
  \item Useful for further speed of recursive divided-and-conquer
    algorithms such as Quicksort
  \item DMD's \texttt{-release} builds keeps range checking % (thanks to Andrei)
  \item DIP-1000 adds static lifetime analysis of pointers to D
    %% \item Inhibit slice checking in Divide-\&-Conquer
    %%   Algorithms. % Describe example on whiteboard
    %% \item Strongly-Typed ``Nullness'' á lá Haskell's \texttt{Maybe}: \texttt{NotNull} or
    %%   \texttt{@nullable}: No more ``null-pointer-exceptions''
    % See also: http://forum.dlang.org/thread/hvjcxxffhbziwbldbchf@forum.dlang.org?page=1
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Numerical Algorithms}
  \begin{itemize}[<+->]
  \item \textbf{N-dimensional slices}:
    \textbf{\texttt{ndslice}} numerical computing glue a la Numpy
  \item \textbf{Mir (mir.dlang.io)}: linear algebra (BLAS), computer vision
    (\texttt{dcv}), etc
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{What's Next?}
  \begin{itemize}[<+->]
    %% \item \textbf{D Language Foundation}
  \item \textbf{Alias Functions} by Stefan Koch avoids template instantiations
    for compile-time operations on enum and types (called traits in C++ and D)
  \item \textbf{Low-Latency GC} using a mark-only collector
  \item \textbf{Copying GC} via precise pointer information
  \item \textbf{Precise GC} via updates to \texttt{TypeInfo}
  \item \textbf{Safe RC} unique feature of D:\@automatically thread-safe (no
    explicit RC-stuff á lá Rust)
  \item and prepared for the Apocalypse: 128-bits Integers: \texttt{cent} and
    \texttt{ucent} are reserved words!
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Commercial Successes}
  \begin{itemize}[<+->]
  \item \href{https://symmetryinvestments.com/}{\textbf{Symmetry Investments}}
  \item \href{https://www.weka.io/}{\textbf{WEKA}}
  \item \textbf{Sociomantic}: D-only company with no initial funding/backing
    bought for \$100M
  \item \textbf{Remedy Games Engine}: replace scripting languages
    %% \item \textbf{Facebook}!: Andrei, Proof-of-Concept, Bounties
  \item \textbf{EMSI}: Economic Modeling Specialists Intl
  \item \textbf{STACK4}: Gameserver Backend written in D 2
  \item \textbf{SR Labs}: Eye Tracking Systems Integrator
  \item \textbf{Funatics Software GmbH}: MMO Game Developer
  \item \textbf{RandomStorm}: network security products and services
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Conclusion: Correctness, Productivity and Performance}
  \begin{itemize}[<+->]
  \item \emph{fastest} compilation of \emph{fast} Code gives
  \item New level of productivity
  \item And static analysis gives
  \item New level of correctness an in turn safety
  \item Among the fastest in execution: https://github.com/kostya/benchmarks
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Good Lectures}
  \begin{itemize}[<+->]
  \item Convinced me to put my bets on D:
    \href{https://www.youtube.com/watch?v=RlVpPstLPEc}{Three Cool Things About D}
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{The End}
  \begin{figure}
    \fbox{\includegraphics[height=0.8\textheight]{borg-vs-mcenroe}}
  \end{figure}
  \emph{Let's} make the best candidate win!
\end{frame}

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\end{document}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: t
%%% End:
